# Middleware to ensure that we clear the context with every request

module Banter
  class Middleware
    @@cached = nil
    def initialize(app)
      @app = app
    end

    def call(env)
      Banter::Context.clear!
      if @@cached.nil?
        @@cached = Banter::Configuration.batch_messages
      end
      if @@cached
        Banter.dedupe_messages { @app.call(env) }
      else
        @app.call(env)
      end
    end
  end
end
